"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ts = require("typescript");
var sourceFile_1 = require("./sourceFile");
var defaultOptions = {
    target: ts.ScriptTarget.Latest,
    module: ts.ModuleKind.CommonJS
};
/** Generate documention for all classes in a set of .ts files */
function getDocumentation(fileName, options) {
    if (options === void 0) { options = defaultOptions; }
    var program = ts.createProgram([fileName], options);
    //noinspection TypeScriptUnresolvedFunction
    var checker = program.getTypeChecker();
    var classes = [];
    var interfaces = [];
    //noinspection TypeScriptUnresolvedFunction
    var sourceFile = program.getSourceFile(fileName);
    var file = new sourceFile_1.SourceFile(sourceFile, checker);
    file.variables.forEach(function (i) { return console.log(i); });
    file.interfaces.forEach(function (i) { return console.log(i); });
    file.classes.forEach(function (i) { return console.log(i); });
    //console.log(fun);
    // log("interfaces: ", file.getInterfaces());
    // log("classes: ", file.getClasses());
    // log("functions: ", file.getFunctions(), i => {
    //     log("valueDeclaration: ", [(i as any).symbol.valueDeclaration]);
    // });
    // log("exports: ", file.getExports());    
    return {
        classes: classes,
        interfaces: interfaces,
    };
}
exports.getDocumentation = getDocumentation;
function getType(prop) {
    var unionType = prop.type;
    if (unionType && unionType.types) {
        return {
            type: 'string',
            values: unionType.types.map(function (i) { return i.getText(); }),
        };
    }
    //noinspection TypeScriptUnresolvedFunction
    return {
        type: prop.type.getText(),
    };
}
//# sourceMappingURL=parser2.js.map